using Models;

namespace ShoopNCook.Views;

public partial class StoredRecipeView : ContentView
{

    private readonly Action<uint> clickCallback;


    public StoredRecipeView(RecipeInfo info, uint personCount, Action<uint> onClickCallback)
    {
        InitializeComponent();

        clickCallback = onClickCallback;

        Note = info.AverageNote;
        Title = info.Name;
        RecipeImage.Source = ImageSource.FromUri(info.Image);
        Counter.Count = personCount;
    }

    public float Note
    {
        set => SetNote(value);
    }

    public string Title
    {
        set => TitleLabel.Text = value;
    }

    private void SetNote(float note)
    {
        int i = 1;
        foreach (Image img in Stars.Children)
        {
            if (i < note)
            {
                img.Opacity = 0;
                i++;
            }
            else img.Opacity = 1;
        }
    }

    private void OnRecipeTapped(object sender, TappedEventArgs e)
    {
        clickCallback(Counter.Count);
    }
}